#!/usr/local/bin/perl

print <<EOF;
/*
 * This file has been automatically generated --- DO NOT EDIT
 */
/*
 * This file can be compiled by prepending
 *
 * #include <cilk.h>
 *
 * The file uses pointers to incomplete structures,
 * but this is ok if the pointers are not dereferenced
 * before the structures are defined
 */
EOF

open (IN, "grep DECLARE_SHARED_VARIABLE @ARGV |");

print "struct Cilk_shared_variables {\n";
while (<IN>) {
    /DECLARE_SHARED_VARIABLE\((.*),(.*),([^)]*)\).*/ ;
    $type = $1;
    $id = $2;
    $other = $3;
    $type =~ s/static //;
    if (!($type =~ /extern/)) {
	print "     $type ${id}${other};\n";
    }
}
print "};\n\n";
close(IN);

open (IN, "grep DECLARE_PRIVATE_VARIABLE @ARGV |");
print "struct Cilk_private_variables {\n";
while (<IN>) {
    /DECLARE_PRIVATE_VARIABLE\((.*),(.*),([^)]*)\).*/ ;
    $type = $1;
    $id = $2;
    $other = $3;
    $type =~ s/static //;
    if (!($type =~ /extern/)) {
	print "     $type ${id}${other};\n";
    }
}
print "     CILK_CACHE_LINE_PAD;\n";
print "};\n\n";
close(IN);

open (IN, "grep DECLARE_SHARED_RO_VARIABLE @ARGV |");
print "struct Cilk_shared_ro_variables {\n";
while (<IN>) {
    /DECLARE_SHARED_RO_VARIABLE\((.*),(.*),([^)]*)\).*/ ;
    $type = $1;
    $id = $2;
    $other = $3;
    $type =~ s/static //;
    if (!($type =~ /extern/)) {
	print "     $type ${id}${other};\n";
    }
}
print "};\n\n";
close(IN);

open (IN, "grep DECLARE_MACHINE_VARIABLE @ARGV |");
print "struct Cilk_machine_variables {\n";
while (<IN>) {
    /DECLARE_MACHINE_VARIABLE\((.*),(.*),([^)]*)\).*/ ;
    $type = $1;
    $id = $2;
    $other = $3;
    $type =~ s/static //;
    if (!($type =~ /extern/)) {
	print "     $type ${id}${other};\n";
    }
}
print "};\n\n";
close(IN);

print "struct Cilk_all_variables {\n";
print "#if CILK_MANAGE_PRIVATE_SEGMENT\n";
print "  char pad1[8192];\n";
print "  struct Cilk_private_variables private;\n";
print "#endif\n";
print "#if CILK_MANAGE_MACHINE_SEGMENT\n";
print "  char pad2[8192];\n";
print "  struct Cilk_machine_variables machine;\n";
print "#endif\n";
print "#if CILK_MANAGE_SHARED_SEGMENT\n";
print "  char pad3[8192];\n";
print "  struct Cilk_shared_variables shared;\n";
print "#endif\n";
print "  char pad4[8192];\n";
print "};\n\n";

print "extern struct Cilk_all_variables Cilk_all_vars;\n\n";
